#bSFVchk 1.0- script for RaidenFTPD by bRave
#
#All config parameters are in bsfvchk.cfg

@site_rec;
print "SFVchk 1.0 - script for RaidenFTPD by bRave\n";
if (open (Cfgfile, "<bsfvchk.cfg") != 1) 
	{
	print "File sfvchk.cfg Not Found!!!\n";
 	exit 0;
	}
$site_section=0;
while ($line = <Cfgfile>)
	{
	if ($site_section ==1)
		{
		if(($site_path,$where_make,$section,$name_format)=$line =~/^(.*)\|(.*)\|(.*)\|(.*)\r*\n*$/)	
			{
			$rec = {};
			$rec->{SITE_PATH} = $site_path;
			$rec->{WHERE_MAKE} = $where_make;
			$rec->{SECTION} = $section;
			$rec->{NAME_FORMAT} = $name_format;
			push @site_rec, $rec;
			}
			elsif ($line =~ /^site_tag_end\s*\r*\n*$/)
			{
			$site_section=0;	
			}
			else
			{
			print "Warning unrecognized line:$line";	
			}		
		}
		else
		{
		if (($tmp)= $line =~ /^create_missing\s*=\s*(.*)\s*\r*\n*$/) {$create_missing=$tmp;}
		elsif (($tmp)= $line =~ /^missing_file\s*=\s*(.*)\r*\n*$/) {$missing_file=$tmp;}
		elsif (($tmp)= $line =~ /^create_relase_incomplete\s*=\s*(.*)\s*\r*\n*$/) {$create_relase_incomplete=$tmp;}
		elsif (($tmp)= $line =~ /^relase_tag\s*=\s*(.*)\s*\r*\n*$/) {$relase_tag=$tmp;}
		elsif (($tmp)= $line =~ /^relase_in_tag\s*=\s*(.*)\r*\n*$/) {$relase_in_tag=$tmp;}
		elsif (($tmp)= $line =~ /^relase_ok_tag\s*=\s*(.*)\r*\n*$/) {$relase_ok_tag=$tmp;}	
		elsif (($tmp)= $line =~ /^create_other_incomplete\s*=\s*(.*)\s*\r*\n*$/) {$create_other_incomplete=$tmp;}	
		elsif ($line =~ /^site_tag_start\s*\r*\n*$/) {$site_section=1;}	
		elsif ($line =~ /^\#.*$/) {;}
		elsif ($line =~ /^\s*\r*\n*$/) {;}
		else {print "Warning unrecognized line:$line";}
		}
	}

close Cfgfile;
@site_rec=sort({$a->{SITE_PATH} <=> $b->{SITE_PATH}} @site_rec);

if (open (Outfile, ">bsfvchk.pl") != 1) 
	{
	print "Error-Can not open output file!!\n";
	exit 0;
	}

print Outfile <<'PART1';
if (@ARGV[0] eq "") {exit 0;} else {$what2do=@ARGV[0];}

for ($what2do) {
        if    (/onSfvUploaded/i)  {sfv_uploaded(); }    
	elsif (/onSfvSuccess/i)   {sfv_success() ; }     
	elsif (/onSfvComplete/i)  {sfv_complete(); }    
	else  {exit 0;}   
	}
PART1
print Outfile <<'PART2';
sub sfv_uploaded
	{
	if (@ARGV[1] eq "") {exit 0;} else {$sfv_count=@ARGV[1];}
	if (@ARGV[2] eq "") {exit 0;} else {$path     =@ARGV[2];}
	if (@ARGV[3] ne "") {exit 0;}
PART2
if ($create_missing==1)
{
print Outfile <<'PART3_1_1';
if (open (Sfvfile, "<$path") != 1) {exit 0;}
	if (($path) = $path=~ /(.*\\)[^\\]*/) {;} else  {exit 0;}

	while ($line = <Sfvfile>)
		{		
		if (($filename) = $line =~ /^([^;].*)\s[A-Za-z0-9]{8}\r*\n*$/)
			{
PART3_1_1
			
$missing_file_tmp = quotemeta $missing_file;
$missing_file_tmp =~ s/\\:f/\$filename/g;
print Outfile 'if (open(Tmpfile, ">$path" . "' . $missing_file_tmp . '") != 1) {exit 0;} else {close Tmpfile;}';

print Outfile <<'PART3_1_2';

			}		
		}
	close Sfvfile;
PART3_1_2
}
else
{
print Outfile <<'PART3_2';
if (($path) = $path=~ /(.*\\)[^\\]*/) {;} else  {exit 0;}
PART3_2
}


if ($create_relase_incomplete ==1)
{ 
print Outfile <<'PART4';
$percent="0";
$good="0";
PART4

$relase_in_tag_tmp = quotemeta $relase_in_tag;
$relase_in_tag_tmp =~ s/\\:g/\$good/g;
$relase_in_tag_tmp =~ s/\\:t/\$sfv_count/g;
$relase_in_tag_tmp =~ s/\\:p/\$percent/g;

if ($relase_tag==0)
{
print Outfile 'if ((mkdir "$path" . "' . $relase_in_tag_tmp . '") != 1) {exit 0;}';
}
elsif ($relase_tag==1)
{
print Outfile 'if (open(Tmpfile, ">$path" . "' . $relase_in_tag_tmp . '") != 1) {exit 0;} else {close Tmpfile;}';	
}

}

if ($create_other_incomplete==1)
{
	if ($create_relase_incomplete ==0)
		{
		print Outfile "\n";
		print Outfile '$percent="0"';
		print Outfile "\n";
		print Outfile '$good="0"';
		}		
	
print Outfile "\n";
print Outfile '($path_nocd, $appname_nocd)= $path =~ /^(.*)\\\\([^\\\\]+)\\\\$/;';
print Outfile "\n";
print Outfile '($path_cd, $appname_cd, $cd)= $path =~ /^(.*)\\\\([^\\\\]+)\\\\([^\\\\]+)\\\\$/;';
print Outfile "\n";

for ($i=$[ ; $i <=$#site_rec ; $i++)
{
$z=$i;
$this_rec=@site_rec[$z]->{SITE_PATH};
$next_rec=quotemeta @site_rec[$i]->{SITE_PATH};

print Outfile "\n";
print Outfile 'if ($path_nocd =~ /^' . $next_rec . '$/i)';
print Outfile "\n";
print Outfile '{';
print Outfile "\n";	

while ($this_rec =~ /^$next_rec$/i )
{
$name_format = quotemeta @site_rec[$i]->{NAME_FORMAT};
$section = quotemeta @site_rec[$i]->{SECTION};
$where_make = quotemeta @site_rec[$i]->{WHERE_MAKE};
$name_format =~ s/\\:s/$section/g;
$name_format =~ s/\\:r/\$appname_nocd/g;
$name_format =~ s/\\:g/\$good/g;
$name_format =~ s/\\:t/\$sfv_count/g;
$name_format =~ s/\\:p/\$percent/g;
$name_format =~ s/\\:a.*\\:c.*\\:b//g;
print Outfile 'if (open(Tmpfile, ">' . $where_make . '" . "\\\\" . "' . $name_format . '") != 1) {exit 0;} else {close Tmpfile;}';
print Outfile "\n";
$i++;
if ($i>$#site_rec) {last;}
$next_rec=quotemeta @site_rec[$i]->{SITE_PATH};
}
$i=$z;
$this_rec=@site_rec[$z]->{SITE_PATH};
$next_rec=quotemeta @site_rec[$i]->{SITE_PATH};
print Outfile "\n";
print Outfile	'}';
print Outfile "\n";
print Outfile 'elsif ($path_cd =~ /^' . $next_rec . '$/i)';
print Outfile "\n";
print Outfile	'{';
print Outfile "\n";

while ($this_rec =~ /^$next_rec$/i )
{
$name_format = quotemeta @site_rec[$i]->{NAME_FORMAT};
$section = quotemeta @site_rec[$i]->{SECTION};
$where_make = quotemeta @site_rec[$i]->{WHERE_MAKE};
$name_format =~ s/\\:s/$section/g;
$name_format =~ s/\\:r/\$appname_cd/g;
$name_format =~ s/\\:g/\$good/g;
$name_format =~ s/\\:t/\$sfv_count/g;
$name_format =~ s/\\:p/\$percent/g;
$name_format =~ s/\\:a//g;
$name_format =~ s/\\:b//g;
$name_format =~ s/\\:c/\$cd/g;
print Outfile 'if (open(Tmpfile, ">' . $where_make . '" . "\\\\" . "' . $name_format . '") != 1) {exit 0;} else {close Tmpfile;}';
print Outfile "\n";
$i++;
if ($i>$#site_rec) {last;}
$next_rec=quotemeta @site_rec[$i]->{SITE_PATH};
}

print Outfile "\n";
print Outfile	'}';
print Outfile "\n";
$i--;
}
}
print Outfile '}';
print Outfile "\n";

# SECTION: onSfvSuccess

print Outfile <<'PART5';
sub sfv_success
	{
	if (@ARGV[1] eq "") {exit 0;} else {$sfv_count=@ARGV[1];}
	if (@ARGV[2] eq "") {exit 0;} else {$path     =@ARGV[2];}
	if (@ARGV[3] eq "") {exit 0;} else {$good     =@ARGV[3];}
	if (@ARGV[4] eq "") {;}       else {exit 0;}

	if (($path , $filename) = $path=~ /(.*\\)([^\\]*)/) {;} else {exit 0;} 
PART5

# SECTION: onSfvSuccess-missing files

if ($create_missing==1)
	{ 
	$missing_file_tmp = quotemeta $missing_file;
 	$missing_file_tmp =~ s/\\:f/\$filename/g;
	print Outfile 'if ((unlink "$path" . "' . $missing_file_tmp . '") != 1) {exit 0;}';
	print Outfile "\n";
	}

# SECTION: onSfvSuccess-Create incomplete and complete tags in relase directory

if ($create_relase_incomplete==1)
	{
		$relase_in_tag_tmp1= quotemeta $relase_in_tag;
		$relase_in_tag_tmp1 =~ s/\\:g/\.\*/g;
		$relase_in_tag_tmp1 =~ s/\\:t/\.\*/g;
		$relase_in_tag_tmp1 =~ s/\\:p/\.\*/g;
		
		$relase_in_tag_tmp2= quotemeta $relase_in_tag;
		$relase_in_tag_tmp2 =~ s/\\:g/\$good/g;
		$relase_in_tag_tmp2 =~ s/\\:t/\$sfv_count/g;
		$relase_in_tag_tmp2 =~ s/\\:p/\$percent/g;	

print Outfile <<'PART6';
	if ($good < $sfv_count)
		{	
		$percent=sprintf "%u",($good/$sfv_count)*100;
		if ((opendir (DIR,$path)) != 1) {exit 0;}
		@dirlist=readdir(DIR);
		closedir DIR;
		foreach $dir_pos (@dirlist) 
			{
PART6

print Outfile		'if ($dir_pos =~ /^' . $relase_in_tag_tmp1 . '$/ )' ;
print Outfile "\n";
print Outfile <<'PART7';
				{
PART7

print Outfile			'if ((rename "$path" . "$dir_pos" , "$path" . "' . $relase_in_tag_tmp2 . '") !=1) {exit 0;}';

print Outfile <<'PART8';
				last;
				}
			}	
		}
PART8
	}
# SECTION: onSfvSuccess-Create incomplete tags in other directories.	

if ($create_other_incomplete==1)
{
print Outfile "\n";
print Outfile '($path_nocd, $appname_nocd)= $path =~ /^(.*)\\\\([^\\\\]+)\\\\$/;';
print Outfile "\n";
print Outfile '($path_cd, $appname_cd, $cd)= $path =~ /^(.*)\\\\([^\\\\]+)\\\\([^\\\\]+)\\\\$/;';
print Outfile "\n";

for ($i=$[ ; $i <=$#site_rec ; $i++)
{
$z=$i;
$this_rec=@site_rec[$z]->{SITE_PATH};
$next_rec=quotemeta @site_rec[$i]->{SITE_PATH};

print Outfile "\n";
print Outfile 'if ($path_nocd =~ /^' . $next_rec . '$/i)';
print Outfile "\n";
print Outfile '{';
print Outfile "\n";	

while ($this_rec =~ /^$next_rec$/i )
{
$name_format = quotemeta @site_rec[$i]->{NAME_FORMAT};
$section = quotemeta @site_rec[$i]->{SECTION};
$where_make = quotemeta @site_rec[$i]->{WHERE_MAKE};
$name_format =~ s/\\:s/$section/g;
$name_format =~ s/\\:r/\$appname_nocd/g;
$name_format =~ s/\\:g/\$good/g;
$name_format =~ s/\\:t/\$sfv_count/g;
$name_format =~ s/\\:p/\$percent/g;
$name_format =~ s/\\:a.*\\:c.*\\:b//g;

$name_format2 = quotemeta @site_rec[$i]->{NAME_FORMAT};
$name_format2 =~ s/\\:s/$section/g;
$name_format2 =~ s/\\:r/\$appname_nocd/g;
$name_format2 =~ s/\\:g/\.\*/g;
$name_format2 =~ s/\\:t/\.\*/g;
$name_format2 =~ s/\\:p/\.\*/g;
$name_format2 =~ s/\\:a.*\\:c.*\\:b//g;


print Outfile <<'PART9';
	if ($good < $sfv_count)
		{	
		$percent=sprintf "%u",($good/$sfv_count)*100;
PART9
print Outfile	'if ((opendir (DIR,"' . $where_make . '")) != 1) {exit 0;}';
print Outfile <<'PART10';
		@dirlist=readdir(DIR);
		closedir DIR;
		foreach $dir_pos (@dirlist) 
			{
PART10

print Outfile		'if ($dir_pos =~ /^' . $name_format2 . '$/ )' ;
print Outfile "\n";
print Outfile <<'PART11';
				{
PART11

print Outfile			'if ((rename "' . $where_make . '" . "\\\\" . "$dir_pos" , "' . $where_make . '" . "\\\\" . "' . $name_format . '") !=1) {exit 0;}';

print Outfile <<'PART12';
				last;
				}
			}	
		}
PART12
print Outfile "\n";
$i++;
if ($i>$#site_rec) {last;}
$next_rec=quotemeta @site_rec[$i]->{SITE_PATH};
}
$i=$z;
$this_rec=@site_rec[$z]->{SITE_PATH};
$next_rec=quotemeta @site_rec[$i]->{SITE_PATH};
print Outfile "\n";
print Outfile	'}';
print Outfile "\n";
print Outfile 'elsif ($path_cd =~ /^' . $next_rec . '$/i)';
print Outfile "\n";
print Outfile	'{';
print Outfile "\n";

while ($this_rec =~ /^$next_rec$/i )
{
$name_format = quotemeta @site_rec[$i]->{NAME_FORMAT};
$section = quotemeta @site_rec[$i]->{SECTION};
$where_make = quotemeta @site_rec[$i]->{WHERE_MAKE};
$name_format =~ s/\\:s/$section/g;
$name_format =~ s/\\:r/\$appname_cd/g;
$name_format =~ s/\\:g/\$good/g;
$name_format =~ s/\\:t/\$sfv_count/g;
$name_format =~ s/\\:p/\$percent/g;
$name_format =~ s/\\:a//g;
$name_format =~ s/\\:b//g;
$name_format =~ s/\\:c/\$cd/g;


$name_format2 = quotemeta @site_rec[$i]->{NAME_FORMAT};
$name_format2 =~ s/\\:s/$section/g;
$name_format2 =~ s/\\:r/\$appname_cd/g;
$name_format2 =~ s/\\:g/\.\*/g;
$name_format2 =~ s/\\:t/\.\*/g;
$name_format2 =~ s/\\:p/\.\*/g;
$name_format2 =~ s/\\:a//g;
$name_format2 =~ s/\\:b//g;
$name_format2 =~ s/\\:c/\$cd/g;


print Outfile <<'PART13';
	if ($good < $sfv_count)
		{	
		$percent=sprintf "%u",($good/$sfv_count)*100;
PART13
print Outfile	'if ((opendir (DIR,"' . $where_make . '")) != 1) {exit 0;}';
print Outfile <<'PART14';
		@dirlist=readdir(DIR);
		closedir DIR;
		foreach $dir_pos (@dirlist) 
			{
PART14

print Outfile		'if ($dir_pos =~ /^' . $name_format2 . '$/ )' ;
print Outfile "\n";
print Outfile <<'PART15';
				{
PART15

print Outfile			'if ((rename "' . $where_make . '" . "\\\\" . "$dir_pos" , "' . $where_make . '" . "\\\\" . "' . $name_format . '") !=1) {exit 0;}';

print Outfile <<'PART16';
				last;
				}
			}	
		}
PART16


print Outfile "\n";
$i++;
if ($i>$#site_rec) {last;}
$next_rec=quotemeta @site_rec[$i]->{SITE_PATH};
}

print Outfile "\n";
print Outfile	'}';
print Outfile "\n";
$i--;
}
	
}
print Outfile '}';

# SECTION: onSfvComplete.

print Outfile <<'PART17';
sub sfv_complete
	{
	if (@ARGV[1] eq "") {exit 0;} else {$sfv_count=@ARGV[1];}	
	if (@ARGV[2] eq "") {exit 0;} else {$path=@ARGV[2];}
	if (@ARGV[3] eq "") {;}       else {exit 0;}

	if (($path) = $path =~ /(.*\\)[^\\]*/) {;} else {exit 0;}
PART17

# SECTION: onSfvComplete-Create incomplete and complete tags in relase directory

if ($create_relase_incomplete==1)
	{
		$relase_in_tag_tmp1= quotemeta $relase_in_tag;
		$relase_in_tag_tmp1 =~ s/\\:g/\.\*/g;
		$relase_in_tag_tmp1 =~ s/\\:t/\.\*/g;
		$relase_in_tag_tmp1 =~ s/\\:p/\.\*/g;
		
		$relase_in_tag_tmp2= quotemeta $relase_ok_tag;
		$relase_in_tag_tmp2 =~ s/\\:t/\$sfv_count/g;
		
		
		

print Outfile <<'PART18';
	if ($good < $sfv_count)
		{	
		$percent=sprintf "%u",($good/$sfv_count)*100;
		if ((opendir (DIR,$path)) != 1) {exit 0;}
		@dirlist=readdir(DIR);
		closedir DIR;
		foreach $dir_pos (@dirlist) 
			{
PART18

print Outfile		'if ($dir_pos =~ /^' . $relase_in_tag_tmp1 . '$/ )' ;
print Outfile "\n";
print Outfile <<'PART19';
				{
PART19

print Outfile			'if ((rename "$path" . "$dir_pos" , "$path" . "' . $relase_in_tag_tmp2 . '") !=1) {exit 0;}';

print Outfile <<'PART20';
				last;
				}
			}	
		}
PART20
	}

# SECTION: onSfvComplete-Create incomplete tags in other directories.	

if ($create_other_incomplete==1)
{
print Outfile "\n";
print Outfile '($path_nocd, $appname_nocd)= $path =~ /^(.*)\\\\([^\\\\]+)\\\\$/;';
print Outfile "\n";
print Outfile '($path_cd, $appname_cd, $cd)= $path =~ /^(.*)\\\\([^\\\\]+)\\\\([^\\\\]+)\\\\$/;';
print Outfile "\n";

for ($i=$[ ; $i <=$#site_rec ; $i++)
{
$z=$i;
$this_rec=@site_rec[$z]->{SITE_PATH};
$next_rec=quotemeta @site_rec[$i]->{SITE_PATH};

print Outfile "\n";
print Outfile 'if ($path_nocd =~ /^' . $next_rec . '$/i)';
print Outfile "\n";
print Outfile '{';
print Outfile "\n";	

while ($this_rec =~ /^$next_rec$/i )
{

$where_make = quotemeta @site_rec[$i]->{WHERE_MAKE};

$name_format2 = quotemeta @site_rec[$i]->{NAME_FORMAT};
$name_format2 =~ s/\\:s/$section/g;
$name_format2 =~ s/\\:r/\$appname_nocd/g;
$name_format2 =~ s/\\:g/\.\*/g;
$name_format2 =~ s/\\:t/\.\*/g;
$name_format2 =~ s/\\:p/\.\*/g;
$name_format2 =~ s/\\:a.*\\:c.*\\:b//g;


print Outfile <<'PART21';
	if ($good < $sfv_count)
		{	
		$percent=sprintf "%u",($good/$sfv_count)*100;
PART21
print Outfile	'if ((opendir (DIR,"' . $where_make . '")) != 1) {exit 0;}';
print Outfile <<'PART22';
		@dirlist=readdir(DIR);
		closedir DIR;
		foreach $dir_pos (@dirlist) 
			{
PART22

print Outfile		'if ($dir_pos =~ /^' . $name_format2 . '$/ )' ;
print Outfile "\n";
print Outfile <<'PART23';
				{
PART23

print Outfile			'if ((unlink "' . $where_make . '" . "\\\\" . "$dir_pos" ) !=1) {exit 0;}';

print Outfile <<'PART24';
				last;
				}
			}	
		}
PART24
print Outfile "\n";
$i++;
if ($i>$#site_rec) {last;}
$next_rec=quotemeta @site_rec[$i]->{SITE_PATH};
}
$i=$z;
$this_rec=@site_rec[$z]->{SITE_PATH};
$next_rec=quotemeta @site_rec[$i]->{SITE_PATH};
print Outfile "\n";
print Outfile	'}';
print Outfile "\n";
print Outfile 'elsif ($path_cd =~ /^' . $next_rec . '$/i)';
print Outfile "\n";
print Outfile	'{';
print Outfile "\n";

while ($this_rec =~ /^$next_rec$/i )
{

$where_make = quotemeta @site_rec[$i]->{WHERE_MAKE};

$name_format2 = quotemeta @site_rec[$i]->{NAME_FORMAT};
$name_format2 =~ s/\\:s/$section/g;
$name_format2 =~ s/\\:r/\$appname_cd/g;
$name_format2 =~ s/\\:g/\.\*/g;
$name_format2 =~ s/\\:t/\.\*/g;
$name_format2 =~ s/\\:p/\.\*/g;
$name_format2 =~ s/\\:a//g;
$name_format2 =~ s/\\:b//g;
$name_format2 =~ s/\\:c/\$cd/g;


print Outfile <<'PART25';
	if ($good < $sfv_count)
		{	
		$percent=sprintf "%u",($good/$sfv_count)*100;
PART25
print Outfile	'if ((opendir (DIR,"' . $where_make . '")) != 1) {exit 0;}';
print Outfile <<'PART26';
		@dirlist=readdir(DIR);
		closedir DIR;
		foreach $dir_pos (@dirlist) 
			{
PART26

print Outfile		'if ($dir_pos =~ /^' . $name_format2 . '$/ )' ;
print Outfile "\n";
print Outfile <<'PART27';
				{
PART27

print Outfile			'if ((unlink "' . $where_make . '" . "\\\\" . "$dir_pos" ) !=1) {exit 0;}';

print Outfile <<'PART28';
				last;
				}
			}	
		}
PART28


print Outfile "\n";
$i++;
if ($i>$#site_rec) {last;}
$next_rec=quotemeta @site_rec[$i]->{SITE_PATH};
}

print Outfile "\n";
print Outfile	'}';
print Outfile "\n";
$i--;
}
	
}	

print Outfile '}';
close Outfile
